<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="98px">
      <el-form-item label="班次号" prop="classesNo">
        <el-input
          v-model="queryParams.likeClassesNo"
          placeholder="请输入班次号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="班结时间" prop="endDate">
        <el-date-picker style="width: 350px"
                        v-model="dateRangeCreatedDate" size="mini" value-format="yyyy-MM-dd HH:mm:ss"
                        type="datetimerange"
                        range-separator="至"
                        start-placeholder="开始日期"
                        end-placeholder="结束日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="班结人" prop="classesMan">
        <el-input
          v-model="queryParams.classesMan"
          placeholder="请输入班结人"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button type="info" icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-table v-loading="loading" :data="summaryList" >
      <el-table-column label="班结主键id" align="center" prop="id" v-if="false" />
      <el-table-column label="班次号" align="center" prop="classesNo" />
      <el-table-column label="班次开始时间" align="center" prop="startDate" width="150">
      </el-table-column>
      <el-table-column label="班次结束时间" align="center" prop="endDate" width="150">
      </el-table-column>
      <el-table-column label="油站id" align="center" prop="stationId" v-if="false" />
      <el-table-column label="油站名称" align="center" prop="stationName" />
      <el-table-column label="订单数" align="center" prop="orderNum" />
      <el-table-column label="小票数量" align="center" prop="printNum" width="50"/>
      <el-table-column label="销量L" align="center" prop="saleLiters" />
      <el-table-column label="应收金额" align="center" prop="saleAmt" />
      <el-table-column label="实收金额" align="center" prop="amt" />
      <el-table-column label="优惠金额" align="center" prop="discountAmt" />
      <el-table-column label="微信支付金额" align="center" prop="wxAmt" />
      <el-table-column label="支付支付金额" align="center" prop="zfbAmt" v-if="false" />
      <el-table-column label="电子卡支付金额" align="center" prop="dzkAmt"  v-if="false"/>
      <el-table-column label="班结人" align="center" prop="classesMan" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-plus"
            @click="handlelook(scope.row)"
          >查看</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-download"
            @click="handleExport(scope.row)"
            v-hasPermi="['station:structure:export']"
          >下载</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <!-- 查看班结数据 -->
    <el-dialog :title="title" :visible.sync="open"  append-to-body class="uncon">
      <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="true" label-width="68px">
        <el-form-item  prop="carNumber">
          开班时间：{{opo.classStartDate}} 班结时间：{{opo.classStructureDate}}班结人：{{opo.classStructureMan}}
        </el-form-item>
      </el-form>
      <!--按员工汇总-->
      <span  style="color:#ff9955;font-size:15px;" >|</span><span style="font-size:15px;">按员工汇总</span>
      <el-table v-loading="loading" show-summary :data="structureList"   :summary-method="getTotal">
        <el-table-column label="员工姓名" align="center" prop="oilPersonnel" />
        <el-table-column label="负责枪号" align="center" prop="oilGun" />
        <el-table-column label="销量" align="center" prop="orderLiters" />
        <el-table-column label="销额" align="center" prop="amt" />
        <el-table-column label="销售笔数" align="center" prop="orderNo" />
      </el-table>
      <!--按油品汇总-->
      <span  style="color:#ff9955;font-size:15px;" >|</span><span style="font-size:15px;">按油品汇总</span>
      <el-table v-loading="loading" :data="structureList1"  show-summary   :summary-method="getTotal2" >
        <el-table-column label="油品" align="center" prop="oilName"  />
        <el-table-column label="负责枪号" align="center" prop="oilGun" />
        <el-table-column label="销量" align="center" prop="orderLiters" />
        <el-table-column label="销额" align="center" prop="amt" />
        <el-table-column label="销售笔数" align="center" prop="orderNo" />
      </el-table>
      <!--按员工/支付方式汇总：    -->
      <span  style="color:#ff9955;font-size:15px;" >|</span><span style="font-size:15px;">按员工/支付方式汇总</span>
      <el-table v-loading="loading" :data="structureList3"  show-summary :summary-method="getTotal3" max-height="h-180">
        <el-table-column label="员工姓名" align="center" prop="oilPersonnel"  />
        <el-table-column label="负责枪号" align="center" prop="oilGun" />
        <el-table-column label="微信笔数" align="center" prop="wxNum" />
        <el-table-column label="支付宝笔数" align="center" prop="zfbNum" />
        <el-table-column label="现金笔数" align="center" prop="xjNum" />
        <el-table-column label="优惠" align="center" prop="discountAmt" />
        <el-table-column label="优惠劵" align="center" prop="discountCouponAmt" />
        <el-table-column label="微信金额" align="center" prop="wxAmt" />
        <el-table-column label="支付宝金额" align="center" prop="zfbAmt" />
        <el-table-column label="现金金额" align="center" prop="xjAmt" />
        <el-table-column label="会员卡支付" align="center" prop="memberAmt"/>
      </el-table>
    </el-dialog>
  </div>
</template>

<script>
import { listSummary } from "@/api/station/summary";
import { exportStructure } from "@/api/station/structure";
import { listPersonnelPayStructure,listClass,listPersonnelStructure,listOilStructure} from "@/api/station/structure";
export default {
  name: "Summary",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 【请填写功能名称】表格数据
      summaryList: [],
      dateRangeCreatedDate: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        classesNo: null,
        startDate: null,
        endDate: null,
        stationId: null,
        stationName: null,
        orderNum: null,
        printNum: null,
        saleLiters: null,
        saleAmt: null,
        wxAmt: null,
        zfbAmt: null,
        dzkAmt: null,
        classesMan: null,
        likeClassesNo:null
      },
      // 查询参数
      queryParam: {
        orderNo: null,
        stationId: null,
        stationName: null,
        oilGun: null,
        oilName: null,
        oilPirce: null,
        oilType: null,
        consumerId: null,
        consumer: null,
        amt: null,
        orderLiters: null,
        payType: null,
        payWay: null,
        payDate: null,
        oilPersonnel: null,
        orderType: null,
        printNum: null,
        classStructureNo: null,
        classStartDate: null,
        classStructureDate: null,
        classStructureMan: null,
        oils: null,
        receivableAmt: null,
        receivedAmt: null,
        discountAmt: null,
        discountCouponAmt: null,
        discountCoupon: null,
        wxAmt: null,
        zfbAmt: null,
        posAmt: null,
        xjAmt: null,
        didiAppAmt: null,
        tyAppAmt: null,
        otherAmt: null,
        dzkAmt: null,
        score: null,
        memberNo: null,
        memberAmt: null,
        carNo: null,
        customerPhone: null,
        customerGrade: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      structureList: [],
      structureList1: [],
      structureList3: [],
      opo:{
        classStartDate:null,
        classStructureMan:null,
        classStructureDate:null,
        classStructureNo:null
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询【请填写功能名称】列表 */
    getList() {
      this.loading = true;
      this.queryParams.stationId=this.$store.selectDeptId;
      if(this.queryParams.stationId==null || this.queryParams.stationId==""){
        this.queryParams.stationId =this.$store.state.user.deptId;
      }
      listSummary(this.addDateRange(this.queryParams, this.dateRangeCreatedDate)).then(response => {
        this.summaryList = response.rows;
        console.log("summaryList",this.summaryList);
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        classesNo: null,
        startDate: null,
        endDate: null,
        stationId: null,
        stationName: null,
        orderNum: null,
        printNum: null,
        saleLiters: null,
        saleAmt: null,
        wxAmt: null,
        zfbAmt: null,
        dzkAmt: null,
        classesMan: null
      };
      this.resetForm("form");
    },

    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.dateRangeCreatedDate =[];
      this.handleQuery();
    },
    handlelook(row){
      //this.$router.push({path:'/station/structure',query:{classesNo:row.classesNo,stationId:row.stationId,name:row.classesMan}});
      this.open = true;
      this.title = "查看班结明细";
       this.queryParams.classStructureMan=row.classesMan;
      this.queryParams.classStructureNo=row.classesNo;
      this.queryParams.stationId=row.stationId;
      listClass(this.queryParams).then(response => {
        this.opo = response.data;
        this.getStructureList();
        this.getStructureList2();
        this.getStructureList3();
      });
    },
    /** 查询班结管理列表 */
    getStructureList() {
      this.loading = true;
      listPersonnelStructure(this.queryParams).then(response => {
        this.structureList = response.rows;
        this.loading = false;
      });
    },
    getStructureList2() {
      this.loading = true;
      listOilStructure(this.queryParams).then(response => {
        this.structureList1 = response.rows;
        this.loading = false;
      });
    },
    getStructureList3() {
      this.loading = true;
      listPersonnelPayStructure(this.queryParams).then(response => {
        this.structureList3 = response.rows;
        this.loading = false;
      });
    },
    getTotal(param) {
      const { columns, data } = param;
      const sums = [];
      columns.forEach((column, index) => {
        if (index === 0) {
          sums[index] = '合计';
          return;
        }
        const values = data.map(item => Number(item[column.property]));
        if (column.property === 'orderLiters') {
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(2);
        }else if(column.property === 'amt'){
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(2);
        }else if(column.property === 'orderNo'){
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(0);
        } else {
          sums[index] = '';
        }
      });
      return sums;
    },
    getTotal2(param) {
      const { columns, data } = param;
      const sums = [];
      columns.forEach((column, index) => {
        if (index === 0) {
          sums[index] = '合计';
          return;
        }
        const values = data.map(item => Number(item[column.property]));
        if (column.property === 'orderLiters') {
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(2);
        }else if(column.property === 'amt'){
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(2);
        }else if(column.property === 'orderNo'){
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(0);
        } else {
          sums[index] = '';
        }
      });
      return sums;
    },
    getTotal3(param) {
      const { columns, data } = param;
      const sums = [];
      columns.forEach((column, index) => {
        if (index === 0) {
          sums[index] = '合计';
          return;
        }
        const values = data.map(item => Number(item[column.property]));
        if (column.property === 'wxNum') {
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(0);
        }else if(column.property === 'zfbNum'){
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(0);
        }else if(column.property === 'xjNum'){
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(0);
        }else if(column.property === 'discountAmt'){
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(2);
        }else if(column.property === 'discountCouponAmt'){
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(2);
        } else if(column.property === 'wxAmt'){
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(2);
        } else if(column.property === 'zfbAmt'){
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(2);
        } else if(column.property === 'xjAmt'){
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(2);
        } else if(column.property === 'memberAmt'){
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          sums[index]=sums[index].toFixed(2);
        } else {
          sums[index] = '';
        }
      });
      return sums;
    },
    /** 导出按钮操作 */
    handleExport(row) {
      const classesNo = row.classesNo;
      this.queryParam.classStructureNo=classesNo;
      this.queryParam.stationId =row.stationId;
      const queryParams = this.queryParam;
      this.$confirm('是否确认导出所有班结数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        return exportStructure(queryParams);
      }).then(response => {
        this.download(response.msg);
      })
    }
  }
};
</script>
<style lang="scss">
.uncon {
  .el-table {
    overflow: auto;
  }
  .el-table--scrollable-x .el-table__body-wrapper {
    overflow-x: visible;
  }
  .el-table__body-wrapper {
    overflow: visible;
  }
  .el-table__header-wrapper {
    overflow: visible;
  }
  .el-table__footer-wrapper {
    overflow: visible;
  }
  .el-table::after {
    position: relative !important;
  }
}
</style>
